; calculate the image center by using a mean and a intensity limit
; IN  image : POINTER TO FLTARR(nx, ny, nz)   image cube
; IN  x     : FLOAT                           old center
; IN  y     : FLOAT                           old center
; IN  z     : FLOAT                           image plane
; OUT cx    : FLOAT                           new image center
; OUT cy    : FLOAT                           new image center
PRO LDRS_CALC_CENTER_MEAN, image, x, y, z, cx, cy, WINSIZE=ws
IF N_ELEMENTS(ws) EQ 0 THEN ws = 32
s = SIZE(image, /DIMENSIONS)
left   = FIX(x - ws)
right  = FIX(x + ws)
bottom = FIX(y - ws)
top    = FIX(y + ws)
IF left LT 0 THEN left = 0
IF right GE s[0] THEN right = s[0]-1
IF bottom LT 0 THEN bottom = 0
IF top GE s[1] THEN top = s[1]-1
w=right-left+1
h=top-bottom+1
n = w*h
ipart = image[left:right,bottom:top,z]
tot = TOTAL(ipart)
imax = MAX(ipart, imaxIdx)
mean = tot/n
sumx=0.0
sumy=0.0
sum = 0.0
limit = mean + 0.1*(imax - mean)
FOR i=0,w-1 DO BEGIN
    FOR j=0,h-1 DO BEGIN
        IF ipart[i,j] GT limit THEN BEGIN
            sum += ipart[i,j]
            sumx += i*ipart[i,j]
            sumy += j*ipart[i,j]
        ENDIF
    ENDFOR
ENDFOR
cx = left + sumx/sum
cy = bottom + sumy/sum
END

