; calculate the image center by using a mean and a intensity limit
; IN  image : POINTER TO FLTARR(nx, ny, nz)   image cube
; IN  x     : FLOAT                           old center
; IN  y     : FLOAT                           old center
; IN  z     : FLOAT                           image plane
; OUT cx    : FLOAT                           new image center
; OUT cy    : FLOAT                           new image center
PRO LDRS_CALC_CENTER_PHASE, image, x, y, z, cx, cy, WINSIZE=ws
IF N_ELEMENTS(ws) EQ 0 THEN ws = 32
s = SIZE(image, /DIMENSIONS)
left   = FIX(x - ws)
right  = FIX(x + ws)
bottom = FIX(y - ws)
top    = FIX(y + ws)
IF left LT 0 THEN left = 0
IF right GE s[0] THEN right = s[0]-1
IF bottom LT 0 THEN bottom = 0
IF top GE s[1] THEN top = s[1]-1
w=right-left+1
h=top-bottom+1
n = w*h
ipart = image[left:right,bottom:top,z]
ipfft = FFT(ipart)
hcx = ipfft[1,0]/ABS(ipfft[1,0])*COMPLEX(-1.0, 0.0)
hcy = ipfft[0,1]/ABS(ipfft[0,1])*COMPLEX(-1.0, 0.0)
xshift = 0.5*ATAN(IMAGINARY(hcx), REAL_PART(hcx))/!PI*w;
yshift = 0.5*ATAN(IMAGINARY(hcy), REAL_PART(hcy))/!PI*h;
PRINT, 'LDRS_CALC_CENTER_PHASE, shift = ', xshift, ', ', yshift
cx = left   + w/2 - xshift
cy = bottom + h/2 - yshift
END

