PRO LDRS_CREATE_MASK, nx, ny, pa, lambda, mask, SIZE=size, CLEAN=clean
IF N_ELEMENTS(mask) EQ 0 THEN mask = FLTARR(nx, ny)
IF N_ELEMENTS(size) EQ 0 THEN size = 1.0
IF N_ELEMENTS(clean) EQ 0 THEN clean=0
IF clean NE 0 THEN mask[*] = 0.0
PRINT, 'LDRS_CREATE_MASK,', nx, ny, pa, lambda
det_dim = nx
det_pix_size=18.0
tel_f_ratio=32.0
obs_lambda = lambda
tel_primary_size=8.4
tel_primary_dist=14.4
tel_combined_size=tel_primary_size+tel_primary_dist
pixscale=det_dim*det_pix_size/tel_f_ratio/obs_lambda/tel_combined_size
ipdist=ROUND(tel_primary_dist*pixscale) ; includes the autocorelation factor 2.0
ipsize=ROUND(tel_primary_size*pixscale*size) ; includes the autocorelation factor 2.0
; first the center disc
FOR y=0,ipsize DO BEGIN
    dx=ROUND(SQRT(ipsize*ipsize - y*y))
    mask[nx/2-dx:nx/2+dx,ny/2-y] = 1.0 ; lower scanline
    mask[nx/2-dx:nx/2+dx,ny/2+y] = 1.0 ; upper scanline
ENDFOR
cx=ROUND(ipdist*COS(pa))
cy=ROUND(ipdist*SIN(pa))
FOR y=0,ipsize DO BEGIN
    dx=ROUND(SQRT(ipsize*ipsize - y*y))
    ; first disc
    mask[nx/2+cx-dx:nx/2+cx+dx,ny/2+cy-y] = 1.0 ; lower scanline
    mask[nx/2+cx-dx:nx/2+cx+dx,ny/2+cy+y] = 1.0 ; upper scanline
    ; second disc
    mask[nx/2-cx-dx:nx/2-cx+dx,ny/2-cy-y] = 1.0 ; lower scanline
    mask[nx/2-cx-dx:nx/2-cx+dx,ny/2-cy+y] = 1.0 ; upper scanline
ENDFOR
END

