;PGROUP1.TAG = "HALO"
;PGROUP1.LABEL = "Halo Compensation"
;PGROUP1.PROC1.TAG = "NONE"
;PGROUP1.PROC1.LABEL = "None"
;PGROUP1.PROC1.PRO = "LDRS_HALO_NONE"
;PGROUP1.PROC2.TAG = "REFLECT"
;PGROUP1.PROC2.LABEL = "Reflect"
;PGROUP1.PROC2.PRO = "LDRS_HALO_REFLECT"
;PGROUP1.PROC3.TAG = "ROT"
;PGROUP1.PROC3.LABEL = "Rotate"
;PGROUP1.PROC3.PRO = "LDRS_HALO_ROTATE"
FUNCTION LDRS_GET_PROCEDURE, tag, nr
COMMON ldrs, env
; find the configuration entry for the procedure group named <tag>
cfg = env.config->LocateByName('PGROUP', /NO_CREATE)
IF NOT OBJ_VALID(cfg) THEN RETURN, 'LDRS_NYI'
cfg = cfg->GetFirst()
WHILE OBJ_VALID(cfg) DO BEGIN
    hcfg = cfg->LocateByName('TAG', /NO_CREATE)
    IF NOT OBJ_VALID(hcfg) THEN BEGIN
        ; no tag value (malformed?), continue with the next entry
        PRINT, 'LDRS_GET_PROCEDURE, PGROUP with nr ', cfg->GetNr(), ' has no tag field, malformed?'
        cfg = cfg->GetNext()
        CONTINUE
    ENDIF
    htag = hcfg->GetString('')
    IF htag NE tag THEN BEGIN
        ; different tag, continue with the next entry
        cfg = cfg->GetNext()
        CONTINUE
    ENDIF
    ; we found the procedure group named <tag>
    hcfg = cfg->LocateByName('PROC', /NO_CREATE)
    IF NOT OBJ_VALID(hcfg) THEN BEGIN
        ; no tag value (malformed?), continue with the next entry
        PRINT, 'LDRS_GET_PROCEDURE, PGROUP with tag ', tag, ' has no associated procedures, malformed?'
        cfg = cfg->GetNext()
        CONTINUE
    ENDIF
    hcfg = hcfg->LocateByNr(nr+1, /NO_CREATE)
    IF NOT OBJ_VALID(hcfg) THEN RETURN, 'LDRS_NYI'
    ; we found the <nr>+1 procedure, now
    ; get the procedure name and call it
    hcfg = hcfg->LocateByName('PRO', /NO_CREATE)
    IF NOT OBJ_VALID(hcfg) THEN RETURN, 'LDRS_NYI'
    RETURN, hcfg->GetString('', DEFAULT='LDRS_NYI')
ENDWHILE
; no procedure found
PRINT, 'LDRS_GET_PROCEDURE, no PGROUP with tag ', tag, $
  ', and PROCEDURE with nr ', nr, $
  ' found, incomplete config file!'
RETURN, 'LDRS_NYI'
END
