PRO LDRS_SKY_BILINEAR, img, cfg, apply, bgrd
topleft = cfg->GetFloat('SKY1')
topright = cfg->GetFloat('SKY2')
bottomleft = cfg->GetFloat('SKY3')
bottomright = cfg->GetFloat('SKY4')
bgrd = (topleft + topright + bottomleft + bottomright)/4
IF apply EQ 0 THEN RETURN
;PRINT, 'LDRS_SKY_BILINEAR, .., ..:', topleft, topright, bottomleft, bottomright
s = SIZE(img, /DIMENSIONS)
nx = s[0]
ny = s[1]
; generate the scale vectors for x- and y-direction (u, 1-u, v, 1-v)
u = FINDGEN(nx)/(nx-1)
ui = (FLTARR(nx) + 1.0) - u
v = FINDGEN(ny)/(ny-1)
vi = (FLTARR(ny) + 1.0) - v
; calculate the border value for the two columns at u=0 and u=1.0
x0 = vi*bottomleft + v*topleft
x1 = vi*bottomright + v*topright
;PRINT, 'x1=', x1
; for each row calculate the linear sky and subtract it from the image
;PRINT, '    LDRS_SKY_BILINEAR: total before=', TOTAL(img)
FOR y=0,ny-1 DO BEGIN
    ;IF y EQ 0 THEN PRINT, 'img[*,0] -=', ui*x0[y] + u*x1[y]
    ;IF y EQ ny-1 THEN PRINT, 'img[*,ny-1] -=', ui*x0[y] + u*x1[y]
    img[*,y] -= ui*x0[y] + u*x1[y]
ENDFOR
;PRINT, '    LDRS_SKY_BILINEAR: total after=', TOTAL(img)
END
