PRO LDRS_SKY_BILINEAR_GUESS, img, sky1, sky2, sky3, sky4
; use the outer part of the image in order to calculate the sky
; background (this case is only valid for the psf sky background)
; if different approaches are required, additional keywords should be
; introduced.
s = SIZE(img, /DIMENSIONS)
nx = s[0]
ny = s[1]
; this is a very simple approach
;sky1 = TOTAL(img[0:15, ny-16:ny-1])/256.0
;sky2 = TOTAL(img[nx-16:nx-1, ny-16:ny-1])/256.0
;sky3 = TOTAL(img[0:15, 0:15])/256.0
;sky4 = TOTAL(img[nx-16:nx-1, 0:15])/256.0

; and now with the help of sfit, using features visible only in the
; source code (/IRREGULAR, ...)
bs = 32 ; use the outer 32 pixel of the image
; convert the x- and y-coordinates into the range 0 .. 1.0
u = FINDGEN(nx)/(nx-1)
v = FINDGEN(ny)/(ny-1)
; the total amount of values is
n = 2*bs*nx + 2*bs*ny - 4*bs*bs ; use the corners only once
values = DBLARR(3, n) ; [0,*]=x, [1,*]=y, [2,*]=z
index = 0
; put the pixels at the lower side into the value array
FOR y=0,bs-1 DO BEGIN
    values[0, index:index+nx-1] = u
    values[1, index:index+nx-1] = v[y]
    values[2, index:index+nx-1] = img[0:nx-1, y]
    index += nx
ENDFOR
; put the pixels at the left and right side into the value array
FOR y=bs,ny-bs-1 DO BEGIN
    ; and now the left side
    values[0, index:index+bs-1] = u[0:bs-1]
    values[1, index:index+bs-1] = v[y]
    values[2, index:index+bs-1] = img[0:bs-1, y]
    index += bs
    ; and now the right side
    values[0, index:index+bs-1] = u[nx-bs:nx-1]
    values[1, index:index+bs-1] = v[y]
    values[2, index:index+bs-1] = img[nx-bs:nx-1, y]
    index += bs
ENDFOR
; put the pixels at the top side into the value array
FOR y=ny-bs,ny-1 DO BEGIN
    values[0, index:index+nx-1] = u
    values[1, index:index+nx-1] = v[y]
    values[2, index:index+nx-1] = img[0:nx-1, y]
    index += nx
ENDFOR
PRINT, 'n=', n, 'index=', index
; and now call sfit
res = sfit(values, 1, KX=param, /IRREGULAR)
PRINT, param
sky3 = param[0, 0]
sky4 = param[1, 0] + sky3
sky1 = param[0, 1] + sky3
sky2 = param[1, 1] - sky3 + sky1 + sky4
END
