PRO LDRS_TRANSLATE_FFT, inImage, outImage, TX=tx, TY=ty
s = SIZE(inImage, /DIMENSIONS)
nx = s[0]
ny = s[1]
center = 0
IF (N_ELEMENTS(tx) EQ 0) AND (N_ELEMENTS(ty) EQ 0) THEN center = 1
IF N_ELEMENTS(tx) EQ 0 THEN tx = 0.0
IF N_ELEMENTS(ty) EQ 0 THEN ty = 0.0
ifft = FFT(inImage)
IF center EQ 1 THEN BEGIN
    cx = ifft[1,0]/ABS(ifft[1,0])*COMPLEX(-1.0, 0.0)
    cy = ifft[0,1]/ABS(ifft[0,1])*COMPLEX(-1.0, 0.0)
    tx = 0.5*ATAN(IMAGINARY(cx), REAL_PART(cx))/!PI*FLOAT(nx)
    ty = 0.5*ATAN(IMAGINARY(cy), REAL_PART(cy))/!PI*FLOAT(ny)
    PRINT, 'LDRS_TRANSLATE_FFT, translate=', tx, ', ', ty
ENDIF
; translate in x direction
FOR x=0, nx-1 DO BEGIN
    IF x LT (nx/2) THEN u = FLOAT(x)/FLOAT(nx) ELSE u = FLOAT(x-nx)/FLOAT(nx)
    p = -2.0*!PI*tx*u
    c = COMPLEX(COS(p), SIN(p))
    FOR y=0,ny-1 DO ifft[x,y] = ifft[x,y]*c
ENDFOR
; translate in y direction
FOR y=0, ny-1 DO BEGIN
    IF y LT (ny/2) THEN v = FLOAT(y)/FLOAT(ny) ELSE v = FLOAT(y-ny)/FLOAT(ny)
    p = -2.0*!PI*ty*v
    c = COMPLEX(COS(p), SIN(p))
    FOR x=0,nx-1 DO ifft[x,y] = ifft[x,y]*c
ENDFOR
IF center EQ 1 THEN BEGIN
    cx = ifft[1,0]/ABS(ifft[1,0])*COMPLEX(-1.0, 0.0)
    cy = ifft[0,1]/ABS(ifft[0,1])*COMPLEX(-1.0, 0.0)
    tx = 0.5*ATAN(IMAGINARY(cx), REAL_PART(cx))/!PI*nx
    ty = 0.5*ATAN(IMAGINARY(cy), REAL_PART(cy))/!PI*ny
    PRINT, '  residual translate=', tx, ', ', ty
ENDIF
outImage = REAL_PART(FFT(ifft, /INVERSE)) ; /FLOAT(nx)/FLOAT(ny)
END
