FUNCTION ldrsBUILDINGBLOCK::Init, algorithm
IF NOT self->ldrsDECONVOLVE::Init(algorithm) THEN RETURN, 0
self.dlgTitle = 'Deconvolution (Building Block) Setup'
self.thresholdMP = '95'
self.threshold = 95.0
RETURN, 1
END

FUNCTION ldrsBUILDINGBLOCK::Prepare
;PRINT, 'ldrsBUILDINGBLOCK::Prepare'
IF NOT self->ldrsDECONVOLVE::Prepare() THEN RETURN, 0
RETURN, 1
END

FUNCTION ldrsDECONVOLVE::ExecuteStep
IF NOT self->ldrsDECONVOLVE::ExecuteStep() THEN RETURN, 0
RETURN, 1
END

FUNCTION ldrsBUILDINGBLOCK::Finish
;PRINT, 'ldrsBUILDINGBLOCK::Finish'
IF NOT self->ldrsDECONVOLVE::Finish() THEN RETURN, 0
RETURN, 1
END

PRO ldrsBUILDINGBLOCK::Load, cfg
self->ldrsDECONVOLVE::Load, cfg
IF OBJ_VALID(cfg) THEN BEGIN
    self.thresholdMP = cfg->GetString('THRESHOLD', DEFAULT='95')
ENDIF
END

PRO ldrsBUILDINGBLOCK::Store, cfg
self->ldrsDECONVOLVE::Store, cfg
IF OBJ_VALID(cfg) THEN BEGIN
    cfg->SetString, 'THRESHOLD', self.thresholdMP
ENDIF
END

; the number of parameters which can have multiple values which are
; used successively
FUNCTION ldrsBUILDINGBLOCK::GetNoMP
RETURN, 1
END

; short tag which is used as a prefix in the generated file name
FUNCTION ldrsBUILDINGBLOCK::GetMPTag, nr
IF nr EQ 0 THEN RETURN, 't'
RETURN, ''
END

; label whch is used in the user interface
FUNCTION ldrsBUILDINGBLOCK::GetMPLabel, nr
IF nr EQ 0 THEN RETURN, 'threshold'
RETURN, ''
END

; get a string which contains all values of a specific parameter
FUNCTION ldrsBUILDINGBLOCK::GetMPValues, nr
IF nr EQ 0 THEN RETURN, self.thresholdMP
RETURN, ''
END

; set a parameter to a specific value which is givan as a string
PRO ldrsBUILDINGBLOCK::SetMP, nr, val
IF nr EQ 0 THEN self.threshold = FLOAT(val)
END

PRO ldrsBUILDINGBLOCK::ReadDynamicContent
self->ldrsDECONVOLVE::ReadDynamicContent
WIDGET_CONTROL, self.dThreshold, SET_VALUE=self.thresholdMP
END

PRO ldrsBUILDINGBLOCK::WriteDynamicContent
self->ldrsDECONVOLVE::WriteDynamicContent
WIDGET_CONTROL, self.dThreshold, GET_VALUE=str
self.thresholdMP = str
END

PRO ldrsBUILDINGBLOCK::CreateContent
self->ldrsDECONVOLVE::CreateContent
row = self->GetFreeRow()
lab             = self->CreateLabel(0, row, 'Threshold[%]:', /HALIGN_RIGHT)
self.dThreshold = self->CreateEntry(2, row, VALUE='95')
row++

END

PRO ldrsBUILDINGBLOCK::InitDialog
self->ldrsDECONVOLVE::InitDialog
senFlag=1
END

PRO ldrsBUILDINGBLOCK__define
struct = { ldrsBUILDINGBLOCK, $
           INHERITS ldrsDECONVOLVE, $
           dThreshold:0, $
           thresholdMP:'', threshold:0.0 $
         }
END
