; Die Informationen, die sich auf einzelne Bilder eines
; Cubes beziehen werden so lange wie moeglich behalten
; und erst dann verworfen wenn das Bild entweder geladen
; wurde oder der Nutzer diese Informationen bearbeiten moechte.
FUNCTION ldrsFILE::Init, filetype
;PRINT, 'ENTER ldrsFILE::Init, tag=', tag
;IF NOT self->IDLitComponent::Init() THEN RETURN, 0
self.filetype = filetype
self.cfg = OBJ_NEW('ldrsCFG', OBJ_NEW(), '', -1)
RETURN, 1
END

FUNCTION ldrsFILE::GetFiletype
RETURN, self.filetype
END

FUNCTION ldrsFILE::GetName
RETURN, self.name
END

PRO ldrsFILE::SetName, name
self.name = name
END

;FUNCTION ldrsFILE::GetNImages
;RETURN, self.nImages
;END

;FUNCTION ldrsFILE::GetNX
;RETURN, self.nx
;END

;FUNCTION ldrsFILE::GetNY
;RETURN, self.ny
;END

;FUNCTION ldrsFILE::GetNZ
;RETURN, self.nImages
;END

FUNCTION ldrsFILE::GetFileCFG
RETURN, self.cfg
END

PRO ldrsFILE::SetFileCFG, cfg
self.cfg = cfg
END

FUNCTION ldrsFILE::CheckContent, wanted
content = self.cfg->GetInt('CONTENT', DEFAULT=3)
PRINT, 'ldrsFILE::CheckContent, wanted=', wanted, ', available=', content
return, (content AND wanted) NE 0
END

;FUNCTION ldrsFILE::GetImageCFG, nr
;hcfg = self.cfg->LocateByName('IMG')
;hhcfg = hcfg->LocateByNr(nr+1)
;RETURN, hhcfg
;END

;PRO ldrsFILE::SetImageCFG, nr, cfg
;IF NOT self->Resize(NIMAGES=nr+1) THEN RETURN
;(*self.cfgs)[nr] = cfg
;END

;FUNCTION ldrsFILE::Resize, nImages=n
;IF self.filetype->GetFormat() NE 1 THEN RETURN, 0
;; if the keyword is not set we have to get the number of
;; images from a fits file
;IF KEYWORD_SET(n) THEN BEGIN
;    IF n LE self.nImages THEN RETURN, 1
;ENDIF ELSE BEGIN
;    IF self.name EQ ''THEN RETURN, 0
;    PRINT, 'ldrsFILE::Resize: testing file ', self.name
;                                ; check if the file exists and is a regular file
;    fi = FILE_INFO(self.name)
;    IF fi.regular NE 1 THEN RETURN, 0
;                                ;read all header keywords from the fits file
;    FITS_OPEN, self.name, fcb
;    FITS_CLOSE, fcb
;                                ; check the dimensions of the primary image
;    IF fcb.naxis[0] EQ 2 THEN BEGIN
;        n = 1
;    ENDIF ELSE BEGIN
;        IF fcb.naxis[0] EQ 3 THEN BEGIN
;            n = fcb.axis[2, 0]
;        ENDIF ELSE BEGIN
;            PRINT, 'ldrsFILE::Resize, naxis[0] > 3!'
;        ENDELSE
;    ENDELSE
;    ; check if the number of images is now defined
;    IF NOT KEYWORD_SET(n) THEN RETURN, 0 ; the keyord is not set and no file available!
;    ; check if the number of images is equal to the old value
;    IF n EQ self.nImages THEN RETURN, 1 ; do nothing
;ENDELSE
;; store the new number of images
;hn = self.nImages
;self.nImages = n
;RETURN, 1
;END

;FUNCTION ldrsFILE::LoadData, FORCE=force
;PRINT, 'ldrsFILE::LoadData, ', self.name
;IF self.filetype->GetFormat() NE 1 THEN RETURN, 0
;IF NOT KEYWORD_SET(force) THEN force = 0
;res = self->Resize()
;IF PTR_VALID(self.data) AND NOT force THEN RETURN, 1
;fi = FILE_INFO(self.name)
;IF fi.regular NE 1 THEN RETURN, 0
;FITS_OPEN, self.name, fcb
;FITS_READ, fcb, data, EXTEN_NO=0, /NO_ABORT, MESSAGE=msg
;FITS_CLOSE, fcb
;IF msg NE '' THEN BEGIN
;    PRINT, 'ldrsFILE::LoadData, ', self.name, ' errmsg=', msg
;    RETURN, 0
;ENDIF
;self.nx = fcb.axis[0, 0]
;self.ny = fcb.axis[1, 0]
;IF PTR_VALID(self.data) THEN PTR_FREE, self.data
;self.data = PTR_NEW(data)
;PRINT, '   => Loaded'
;RETURN, 1
;END

;FUNCTION ldrsFILE::StoreData
;IF NOT PTR_VALID(self.data) THEN RETURN, 0
;FITS_WRITE, self.name, *self.data, /NO_ABORT, MESSAGE=msg
;IF msg NE '' THEN BEGIN
;    PRINT, 'ldrsFILE::StoreData, ', self.name, ' errmsg=', msg
;    RETURN, 0
;ENDIF
;RETURN, 1
;END

;PRO ldrsFILE::CreateData, nx, ny, nz, FORCE=force
;IF self.filetype->GetFormat() NE 1 THEN RETURN
;IF N_ELEMENTS(force) EQ 0 THEN force = 0
;IF PTR_VALID(self.data) AND NOT force THEN RETURN
;data = FLTARR(nx, ny, nz)
;self.nx = nx
;self.ny = ny
;self.nImages = nz
;IF PTR_VALID(self.data) THEN PTR_FREE, self.data
;self.data = PTR_NEW(data)
;END

;FUNCTION ldrsFILE::GetData
;RETURN, self.data
;END

PRO ldrsFILE::Store, cfg
IF STRMID(self.name, 0, 1) EQ PATH_SEP() THEN BEGIN
    recipe = self.filetype->GetRecipe()
    recName = recipe->GetName()
    self.cfg->SetString, 'NAME', LDRS_ENCODE_FILENAME(recName, self.name)
ENDIF ELSE BEGIN
    self.cfg->SetString, 'NAME', self.name
ENDELSE
self.cfg->CloneChildren, cfg
END

PRO ldrsFILE::Load, cfg
cfg->MoveChildren, self.cfg
self.name = self.cfg->GetString('NAME')
IF STRMID(self.name, 0, 1) NE PATH_SEP() THEN BEGIN
    recipe = self.filetype->GetRecipe()
    recName = recipe->GetName()
    self.name = LDRS_DECODE_FILENAME(recName, self.name)
ENDIF
END

PRO ldrsFILE__define
struct = { ldrsFILE, $
           filetype:OBJ_NEW(), $
           name:'', $
           cfg:OBJ_NEW() $
         }
END
