; FILE.<tag><i>.OBS.LAMBDA
; FILE.<tag><i>.IMG<j>.OBS.PA
FUNCTION ldrsFILEINFO::Init
IF NOT self->ldrsDIALOG::Init() THEN RETURN, 0
self.dlgTitle = 'File Information'
RETURN, 1
END

PRO ldrsFILEINFO::ReadDynamicContent
IF NOT OBJ_VALID(self.type) THEN RETURN
IF NOT OBJ_VALID(self.file) THEN RETURN
cfg = self.file->GetImageCFG(self.imgNr)
IF OBJ_VALID(cfg) THEN BEGIN
    rotator = cfg->GetFloat('OBS.ROTATOR', DEFAULT=0.0)
    WIDGET_CONTROL, self.dlgObsRotator, SET_VALUE=STRING(FORMAT='(F4.2)', rotator)
    bgrd = cfg->GetFloat('BGRD', DEFAULT=0.0)
    WIDGET_CONTROL, self.dlgBackground, SET_VALUE=STRING(FORMAT='(F10.2)', bgrd)
ENDIF ELSE BEGIN
    WIDGET_CONTROL, self.dlgObsRotator, SET_VALUE='0.0'
    WIDGET_CONTROL, self.dlgBackground, SET_VALUE='0.0'
ENDELSE
END

PRO ldrsFILEINFO::WriteDynamicContent
IF NOT OBJ_VALID(self.type) THEN RETURN
IF NOT OBJ_VALID(self.file) THEN RETURN
cfg = self.file->GetImageCFG(self.imgNr)
WIDGET_CONTROL, self.dlgObsRotator, GET_VALUE=str
cfg->SetFloat, 'OBS.ROTATOR', FLOAT(str)
WIDGET_CONTROL, self.dlgBackground, GET_VALUE=str
cfg->SetFloat, 'BGRD', FLOAT(str)
END

PRO ldrsFILEINFO::ButtonPressed, id
CASE id OF
    self.dlgPrevBtn: self->GotoPrev
    self.dlgNextBtn: self->GotoNext
    ELSE:
ENDCASE
END

PRO ldrsFILEINFO::GotoNext
IF NOT OBJ_VALID(self.type) THEN RETURN
IF NOT OBJ_VALID(self.file) THEN RETURN
IF self.imgNr GE self.nImages - 1 THEN RETURN
self->WriteDynamicContent
self.imgNr += 1
WIDGET_CONTROL, self.dlgNrTxt, SET_VALUE=STRING(FORMAT='(I0)', self.imgNr)
self->ReadDynamicContent
END

PRO ldrsFILEINFO::GotoPrev
IF NOT OBJ_VALID(self.type) THEN RETURN
IF NOT OBJ_VALID(self.file) THEN RETURN
IF self.imgNr EQ 0 THEN RETURN
self->WriteDynamicContent
self.imgNr -= 1
WIDGET_CONTROL, self.dlgNrTxt, SET_VALUE=STRING(FORMAT='(I0)', self.imgNr)
self->ReadDynamicContent
END

PRO ldrsFILEINFO::ReadStaticContent
IF NOT OBJ_VALID(self.type) THEN RETURN
IF NOT OBJ_VALID(self.file) THEN RETURN
WIDGET_CONTROL, self.dlgFilename, SET_VALUE=self.file->GetName()
res = self.file->Resize()
self.imgNr = 0
self.nImages = self.file->GetNImages()
WIDGET_CONTROL, self.dlgNrTxt, SET_VALUE=STRING(FORMAT='(I0)', self.imgNr)
; get the observation wavelength from the file
cfg = self.file->GetFileCFG()
IF OBJ_VALID(cfg) THEN BEGIN
    lambda = cfg->GetFloat('OBS.LAMBDA', DEFAULT=1.2)
    WIDGET_CONTROL, self.dlgObsLambda, SET_VALUE=STRING(FORMAT='(F4.2)', lambda)
    content = cfg->GetInt('CONTENT', DEFAULT=3)
    WIDGET_CONTROL, self.dlgPsfContent, SET_VALUE=content MOD 2
    WIDGET_CONTROL, self.dlgTargetContent, SET_VALUE=(content/2) MOD 2
ENDIF ELSE BEGIN
    WIDGET_CONTROL, self.dlgObsLambda, SET_VALUE='0.0'
    WIDGET_CONTROL, self.dlgPsfContent, SET_VALUE=0
    WIDGET_CONTROL, self.dlgTargetContent, SET_VALUE=0
ENDELSE
self->ReadDynamicContent
END

PRO ldrsFILEINFO::WriteStaticContent
IF NOT OBJ_VALID(self.type) THEN RETURN
IF NOT OBJ_VALID(self.file) THEN RETURN
cfg = self.file->GetFileCFG()
WIDGET_CONTROL, self.dlgObsLambda, GET_VALUE=str
cfg->SetFloat, 'OBS.LAMBDA', FLOAT(str)
WIDGET_CONTROL, self.dlgPsfContent, GET_VALUE=psfFlag
WIDGET_CONTROL, self.dlgTargetContent, GET_VALUE=targetFlag
cfg->SetInt, 'CONTENT', targetFlag*2 + psfFlag
END

PRO ldrsFILEINFO::Edit, top, ft, file
self.type = ft
self.file = file
self->CreateDialog, top
self->ReadStaticContent
;self->ReadDynamicContent
self->ShowDialog
END

PRO ldrsFILEINFO::CreateContent
self->ldrsDIALOG::CreateContent
row = self->GetFreeRow()

lab                = self->CreateLabel(0, row, 'Filename:', /HALIGN_RIGHT)
self.dlgFilename   = self->CreateEntry(1, row, VALUE='', XSIZE=50, NX=4)
row++

lab                = self->CreateLabel(0, row, 'Lambda:', /HALIGN_RIGHT)
self.dlgObsLambda  = self->CreateEntry(1, row, VALUE=STRING(0.0), NX=2)
row++

lab                = self->CreateLabel(0, row,'Image:', /HALIGN_RIGHT)
self.dlgPrevBtn    = self->CreateButton(1, row, '<', /HALIGN_RIGHT)
self.dlgNrTxt      = self->CreateEntry(2, row, VALUE='0')
self.dlgNextBtn    = self->CreateButton(3, row, '>', /HALIGN_LEFT)
row++

lab                = self->CreateLabel(0, row, 'Rotator:', /HALIGN_RIGHT)
self.dlgObsRotator = self->CreateEntry(1, row, VALUE=STRING(0.0), NX=2)
row++

lab                = self->CreateLabel(0, row, 'Background:', /HALIGN_RIGHT)
self.dlgBackground = self->CreateEntry(1, row, VALUE=STRING(0.0), NX=2)
row++

lab                   = self->CreateLabel(0, row, 'Content:', /HALIGN_RIGHT)
self.dlgPsfContent    = self->CreateCheckbox(1, row, 'PSF')
self.dlgTargetContent = self->CreateCheckbox(2, row, 'Target')
row++
END

PRO ldrsFILEINFO__define
struct = { ldrsFILEINFO, $
           INHERITS ldrsDIALOG, $
           type:OBJ_NEW(), $
           file:OBJ_NEW(), $
           imgNr:0, $
           nImages:0, $
           dlgFilename:0, $
           dlgObsLambda:0, $
           dlgPrevBtn:0, $
           dlgNrTxt:0, $
           dlgNextBtn:0, $
           dlgObsRotator:0, dlgBackground:0, $
           dlgPsfContent:0, dlgTargetContent:0 $
         }
END
