PRO LDRS_FILELIST_SELECT, Event
COMMON ldrs, env
ft = env.recipe->GetSelectedFiletype()
IF NOT OBJ_VALID(ft) THEN RETURN
selNr = Event.index
file = ft->GetFile(selNr)
env.recipe->SelectFile, file
IF Event.clicks EQ 2 THEN LDRS_FILE_EDIT, Event
END

FUNCTION ldrsFILELIST::Init, cfg, frame
IF NOT self->ldrsVIEW::Init(cfg, frame) THEN RETURN, 0

RETURN, 1
END

PRO ldrsFILELIST::FiletypeSelected, filetype
COMMON ldrs, env
WIDGET_CONTROL, self.dPrefix, SET_VALUE=filetype->GetPrefix()
nFiles = filetype->GetNFiles()
IF nFiles EQ 0 THEN BEGIN
    WIDGET_CONTROL, self.guiPanel, SET_VALUE='<EMPTY>', SENSITIVE=0
    self->EnableButtons
    RETURN
END
arr = STRARR(nFiles)
FOR i = 0, nFiles - 1 DO BEGIN
    file = filetype->GetFile(i)
    arr[i] = file->GetName()
ENDFOR
WIDGET_CONTROL, self.guiPanel, SET_VALUE=arr, SENSITIVE=1
self->EnableButtons
END

PRO ldrsFILELIST::FiletypeDeselected, filetype
COMMON ldrs, env
WIDGET_CONTROL, self.guiPanel, SET_VALUE='<EMPTY>', SENSITIVE=0
self->DisableButtons
END

PRO ldrsFILELIST::FiletypeChanged, filetype
COMMON ldrs, env
ft = env.recipe->GetSelectedFiletype()
IF ft EQ filetype THEN self->FiletypeSelected, filetype
END

PRO ldrsFILELIST::PrefixChanged, filetype
WIDGET_CONTROL, self.dPrefix, SET_VALUE=filetype->GetPrefix()
END

PRO ldrsFILELIST::FileCreated, file
self->FiletypeSelected, file->GetFiletype()
END

PRO ldrsFILELIST::FileChanged, file
self->FiletypeSelected, file->GetFiletype()
END

PRO ldrsFILELIST::FileRemoved, filetype
self->FiletypeSelected, filetype
END

PRO ldrsFILELIST::CreateContent, cfgPanel
;PRINT, 'ldrsFILELIST::CreateContent called'
self.guiPanel = WIDGET_LIST(self.guiBase, SENSITIVE=0, UNITS=0, $
                            SCR_XSIZE=self.scrSize[0], SCR_YSIZE=self.scrSize[1], $
                            EVENT_PRO='LDRS_FILELIST_SELECT')
preBase = WIDGET_BASE(self.guiBase, /ROW)
lab = WIDGET_LABEL(preBase, VALUE='Prefix:')
geo = WIDGET_INFO(lab, /GEOMETRY)
self.dPrefix = WIDGET_TEXT(preBase, VALUE='', SCR_XSIZE=self.scrSize[0] - geo.scr_xsize - 10)
END

PRO ldrsFILELIST__define
  struct = { ldrsFILELIST, $
             INHERITS ldrsVIEW, $
             dPrefix:0 $
           }
END
