PRO LDRS_IMAGE_EVENT, event
WIDGET_CONTROL, event.id, GET_UVALUE=img
IF OBJ_VALID(img) THEN img->DoEvent, event
END

PRO LDRS_IMAGE_NEXT, event
WIDGET_CONTROL, event.id, GET_UVALUE=img
IF OBJ_VALID(img) THEN img->GotoNext
END

PRO LDRS_IMAGE_PREV, event
WIDGET_CONTROL, event.id, GET_UVALUE=img
IF OBJ_VALID(img) THEN img->GotoPrev
END

PRO LDRS_IMAGE_COLOR, event
WIDGET_CONTROL, event.id, GET_UVALUE=img
IF OBJ_VALID(img) THEN img->SelectPalette, event.index
END

FUNCTION ldrsIMAGE::Init, cfg, frame
IF NOT self->ldrsVIEW::Init(cfg, frame) THEN RETURN, 0
self.scaleF = 1.0
RETURN, 1
END

PRO ldrsIMAGE::RelToUser, dx, dy, ux, uy
ux = dx/self.scaleF
uy = dy/self.scaleF
END

PRO ldrsIMAGE::AbsToUser, dx, dy, ux, uy
ux = dx/self.scaleF + self.viewOrgX
uy = dy/self.scaleF + self.viewOrgY
END

PRO ldrsIMAGE::CreateExtensions
IF NOT OBJ_VALID(self.imgFile) THEN RETURN
FOR i = 0,self.nTools-1 DO BEGIN
    tool = self.tools[i]->GetImpl()
    tool->CreateImageExtension, self.imgExt, self.imgFile, self.imgImgNr
ENDFOR
; create all image and processing step specific image extensions
;procDef = env.recipeDef->FindProcDef(ienv.procTag)
;nTools = procDef->GetNTools()
;FOR i=0,nTools-1 DO BEGIN
;    tag = procDef->GetTool(i)
;        IF ienv.toolTags[j] NE tag THEN CONTINUE
;        BREAK
;ENDFOR
;iePro = procDef->GetImgExtPro()
;PRINT, 'LDRS_IMAGE_SHOW: procDef=', procDef->GetTag(), ', iePro=', iePro
;IF iePro NE '' THEN CALL_PROCEDURE, iePro, ienv.imgExt, ienv.file, nr
END

PRO ldrsIMAGE::RemoveExtensions
; destroy all objects in the image extension
FOR i = 0,self.nTools-1 DO BEGIN
    tool = self.tools[i]->GetImpl()
    tool->ImageExtensionDestroyed, self.imgExt, self.imgFile, self.imgImgNr
ENDFOR
ie = self.imgExt->Get(/ALL, COUNT=iecnt)
self.imgExt->Remove, /ALL
FOR i=0,iecnt-1 DO OBJ_DESTROY, ie[i]
END

PRO ldrsIMAGE::ChangeView, RESET=reset, ZOOM=zoom, GCENTER=gcenter, ICENTER=icenter, MOVE=delta, RESIDUAL=res
self.imgView->GetProperty, VIEWPLANE_RECT=vr
vrX = vr[0]
vrY = vr[1]
vrW = vr[2]
vrH = vr[3]
ovrX = vrX
ovrY = vrY
vcX = vrX + vrW/2
vcY = vrY + vrH/2
IF KEYWORD_SET(reset) THEN BEGIN
    IF self.drW LT self.scrSize[0] THEN sx = self.scrSize[0]/self.drW - 1 ELSE sx = -(self.drW + self.scrSize[0] - 1)/self.scrSize[0] + 1
    IF self.drH LT self.scrSize[1] THEN sy = self.scrSize[1]/self.drH - 1 ELSE sy = -(self.drH + self.scrSize[1] - 1)/self.scrSize[1] + 1
    IF sx LT sy THEN self.scale = sx ELSE self.scale = sy
    vcX = self.drW/2
    vcY = self.drH/2
ENDIF
IF KEYWORD_SET(zoom) THEN self.scale += zoom
IF self.scale GT  20 THEN self.scale =  20
IF self.scale LT -20 THEN self.scale = -20

IF KEYWORD_SET(gcenter) THEN BEGIN
    vcX = vrX + gcenter[0]/self.scaleF
    vcY = vrY + gcenter[1]/self.scaleF
ENDIF
IF KEYWORD_SET(icenter) THEN BEGIN
    vcX = icenter[0]
    vcY = icenter[1]
ENDIF
IF KEYWORD_SET(delta) THEN BEGIN
    vcX = vrX + (self.scrSize[0]/2 - delta[0])/self.scaleF
    vcY = vrY + (self.scrSize[1]/2 - delta[1])/self.scaleF
ENDIF
IF self.scale EQ 0 THEN BEGIN
    ;no zoom
    vrW = self.scrSize[0]
    vrH = self.scrSize[1]
    self.scaleF = 1.0
ENDIF ELSE BEGIN
    IF self.scale GT 0 THEN BEGIN
        ;zoom in
        vrW = self.scrSize[0]/(self.scale + 1)
        vrH = self.scrSize[1]/(self.scale + 1)
        self.scaleF = self.scale + 1.0
    ENDIF ELSE BEGIN
        ;zoom out
        vrW = self.scrSize[0]*(-self.scale + 1)
        vrH = self.scrSize[1]*(-self.scale + 1)
        self.scaleF = 1.0/(-self.scale + 1.0)
    ENDELSE
ENDELSE
vrX = FIX(vcX - vrW/2)
vrY = FIX(vcY - vrH/2)
IF KEYWORD_SET(delta) AND KEYWORD_SET(res) THEN BEGIN
    res = [delta[0] - (ovrX - vrX)*self.scaleF, delta[1] - (ovrY - vrY)*self.scaleF]
    ;PRINT, 'ldrsIMAGE::ChangeView: ovr=', ovrX, ovrY, ', vr=', vrX, vrY, ', residual=', res[0], res[1]
ENDIF
self.viewOrgX = vrX
self.viewOrgY = vrY
;PRINT, 'ldrsIMAGE::ChangeView: view plane=', vrX, vrY, vrW, vrH
self.imgView->SetProperty, VIEWPLANE_RECT=[vrX, vrY, vrW, vrH]
self.imgWin->DRAW, self.imgView
END

FUNCTION ldrsIMAGE::Select, x, y
RETURN, self.imgWin->Select(self.imgView, [x, y])
END

PRO ldrsIMAGE::Redraw
self.imgWin->DRAW, self.imgView
END

PRO ldrsIMAGE::Update, RESET=reset
COMMON ldrs, env
self->RemoveExtensions
dataMin = MIN((*self.imgData)[*,*,self.imgImgNr])
data = BYTSCL(ALOG((*self.imgData)[*,*,self.imgImgNr] - dataMin + 1.0))
;data = BYTSCL(SQRT((*self.imgData)[*,*,self.imgImgNr] - dataMin))
s = SIZE(data, /DIMENSIONS)
self.drW = s[0]
self.drH = s[1]
self.imgImage->SetProperty, DIMENSIONS=s, DATA=data
self->CreateExtensions
WIDGET_CONTROL, self.guiNrTxt, SET_VALUE=STRING(FORMAT='(I0)', self.imgImgNr)
self->ChangeView, RESET=reset
END

PRO ldrsIMAGE::GotoNext
IF self.imgImgNr EQ self.imgNImages - 1 THEN RETURN
self.imgImgNr += 1
self->Update
END

PRO ldrsIMAGE::GotoPrev
IF self.imgImgNr EQ 0 THEN RETURN
self.imgImgNr -= 1
self->Update
END

PRO ldrsIMAGE::GetImage, image, nr
IF NOT PTR_VALID(self.imgData) THEN BEGIN
    image = PTR_NEW()
    nr = 0
    RETURN
ENDIF
image = self.imgData
nr = self.imgImgNr
END

PRO ldrsIMAGE::SelectPalette, nr
CASE nr OF
    0: self.imgPalette->LoadCT,0
    1: self.imgPalette->LoadCT,13
    2: self.imgPalette->LoadCT,3
    ELSE: self.imgPalette->LoadCT,0
ENDCASE
self.imgImage->SetProperty, PALETTE=self.imgPalette
self.imgWin->DRAW, self.imgView
END

PRO ldrsIMAGE::SelectTool, tool
IF OBJ_VALID(self.selTool) THEN BEGIN
    self.selTool->Deselect
    self.selTool = OBJ_NEW()
ENDIF
IF OBJ_VALID(tool) THEN BEGIN
    self.selTool = tool
    self.selTool->Select
    tool = self.selTool->GetImpl()
    tool->Activate, self
ENDIF
END

PRO ldrsIMAGE::DoEvent, event
IF NOT OBJ_VALID(self.selTool) THEN RETURN
tool = self.selTool->GetImpl()
IF NOT OBJ_VALID(tool) THEN RETURN
tool->DoEvent, event
END

PRO ldrsIMAGE::FileLoaded, file
self.imgFile = file
self.imgNImages = file->GetNImages()
self.imgImgNr = 0
self.imgData = self.imgFile->GetData()
WIDGET_CONTROL, self.guiFileName, SET_VALUE=file->GetName()
self->Update, /RESET
END

PRO ldrsIMAGE::ShowImage, IMAGE=image, NAME=name
self.imgFile = OBJ_NEW()
s = SIZE(*image, /DIMENSIONS)
IF N_ELEMENTS(s) EQ 3 THEN self.imgNImages = s[2] ELSE self.imgNImages = 1
self.imgImgNr = 0
self.imgData = image
WIDGET_CONTROL, self.guiFileName, SET_VALUE=name
self->Update, /RESET
END

PRO ldrsIMAGE::CreateLabel, cfgPanel
END

PRO ldrsIMAGE::CreateContent, cfgPanel
COMMON ldrs, env
;PRINT, 'ldrsIMAGE::CreateContent called'
; create the header widgets (filename, imagenr, colormap, tools, ...)
hbase = WIDGET_BASE(self.guiBase, /ROW, SPACE=0, XPAD=0, YPAD=0)
; file name
fnl = WIDGET_LABEL(hbase, VALUE='File:')
self.guiFileName = WIDGET_TEXT(hbase, VALUE='', XSIZE=50) 
; image number
il = WIDGET_LABEL(hbase, VALUE='Image:')
self.guiPrevBtn = WIDGET_BUTTON(hbase, VALUE='<', EVENT_PRO='LDRS_IMAGE_PREV', SENSITIVE=1, UVALUE=self)
self.guiNrTxt   = WIDGET_TEXT(hbase, /EDITABLE, VALUE='0', XSIZE=3)
self.guiNextBtn = WIDGET_BUTTON(hbase, VALUE='>', EVENT_PRO='LDRS_IMAGE_NEXT', SENSITIVE=1, UVALUE=self)
; Colormap
pl = WIDGET_LABEL(hbase, VALUE='Color:')
pcb = WIDGET_COMBOBOX(hbase, EVENT_PRO='LDRS_IMAGE_COLOR', /SENSITIVE, $
                      VALUE=[ 'Gray', 'Rainbow', 'Blackbody' ], UVALUE=self)
; tools
hbase = WIDGET_BASE(self.guiBase, /ROW, SPACE=0, XPAD=0, YPAD=0)
tl = WIDGET_LABEL(hbase, VALUE='Tools:')
cfg = env.config->Locate('TOOL')
IF OBJ_VALID(cfg) THEN BEGIN
    cfg = cfg->GetFirst()
    WHILE OBJ_VALID(cfg) DO BEGIN
        self.tools[self.nTools] = OBJ_NEW('ldrsTOOL', self, cfg)
        self.tools[self.nTools]->CreateGUI, hbase, cfg
;    ;PRINT, 'LDRS_IMAGE creating tool ', ienv.toolTags[ienv.nTools], ' widget is ', ienv.toolBtns[ienv.nTools]
        self.nTools++
        cfg = cfg->GetNext()
    ENDWHILE
ENDIF
; image panel
self.guiPanel = WIDGET_DRAW(self.guiBase, /EXPOSE_EVENTS, $
                            UNITS=0, SCR_XSIZE=self.scrSize[0], SCR_YSIZE=self.scrSize[1], $
                            GRAPHICS_LEVEL=2, RENDERER=1, $
                            /BUTTON_EVENTS, /MOTION_EVENTS, EVENT_PRO='LDRS_IMAGE_EVENT', $
                            UVALUE=self)
END

PRO ldrsIMAGE::CreateButtons, cfgPanel
END

PRO ldrsIMAGE::RealizeGUI
COMMON ldrs, env
WIDGET_CONTROL, self.guiPanel, GET_VALUE = oWindow
self.imgWin = oWindow
; create all basic image objects (font, view, and graph)
;width = self.scrSize[0]
;height = self.scrSize[1]
;self.imgView = OBJ_NEW('IDLgrView', COLOR=[0,0,0], UNITS=0,
;LOCATION=[0, 0], DIMENSIONS=[width, height], VIEWPLANE_RECT=[0, 0,
;width, height])
; resize the drawing widget acording to the available width
bgeo = WIDGET_INFO(self.guiBase, /GEOMETRY)
pgeo = WIDGET_INFO(self.guiPanel, /GEOMETRY)
width = max([pgeo.scr_xsize, bgeo.scr_xsize])
height = pgeo.scr_ysize
WIDGET_CONTROL, self.guiPanel, SCR_XSIZE=width
self.scrSize = [width, height]
pgeo = WIDGET_INFO(self.guiPanel, /GEOMETRY)
width = pgeo.scr_xsize
height = pgeo.scr_ysize
;PRINT, 'ldrsIMAGE::RealizeGUI, size:', width, height
; create the drawing view
self.imgView = OBJ_NEW('IDLgrView', COLOR=[0,0,0], UNITS=0, VIEWPLANE_RECT=[0, 0, width, height])
;self.imgView = OBJ_NEW('IDLgrView', COLOR=[0,0,0], UNITS=0, DIMENSIONS=[width, height])
self.imgWin->SetProperty, GRAPHICS_TREE=self.imgView
self.imgModel = OBJ_NEW('IDLgrModel')
self.imgView->Add, self.imgModel
aRed   = INDGEN(256, /BYTE)
aGreen = INDGEN(256, /BYTE)
aBlue  = INDGEN(256, /BYTE)
self.imgPalette = OBJ_NEW('IDLgrPalette', aRed, aGreen, aBlue)
self.imgPalette->LoadCT, 0
;di = INDGEN(256, 256, /BYTE)
di = BYTARR(256, 256)
self.imgImage = OBJ_NEW('IDLgrImage', PALETTE=self.imgPalette, LOCATION=[0, 0], DIMENSIONS=[256, 256], DATA=di)
self.imgModel->ADD, self.imgImage
;
font = OBJ_NEW('IDLgrFont', SIZE=self.fontSize)
;labelObj = OBJ_NEW('IDLgrText', 'EMPTY', $
;                        COLOR=[128, 128, 128], $
;                        LOCATIONS=[width/2, height/2, 1], $
;                        VERTICAL_ALIGNMENT=0.5, $
;                        RECOMPUTE_DIMENSIONS=1, $
;                        FONT=font)
self.imgExt = OBJ_NEW('IDLgrModel')
self.imgModel->ADD, self.imgExt
;self.imgExt->ADD, labelObj
self.imgWin->DRAW, self.imgView
END

FUNCTION ldrsIMAGE::Resize, dw, dh
;PRINT, 'ldrsIMAGE::Resize', dw, ',', dh
geo = WIDGET_INFO(self.guiPanel, /GEOMETRY)
;PRINT, '   old geo: ', geo
ow = geo.scr_xsize
oh = geo.scr_ysize
WIDGET_CONTROL, self.guiPanel, SCR_XSIZE=ow+dw, SCR_YSIZE=oh+dh
geo = WIDGET_INFO(self.guiPanel, /GEOMETRY)
;PRINT, '   new geo: ', geo
self.imgView->GetProperty, VIEWPLANE_RECT=vr
;PRINT, 'ldrsIMAGE::Resize old vr=', vr
vw = dw/self.scaleF
vh = dh/self.scaleF
self.imgView->SetProperty, VIEWPLANE_RECT=[vr[0] - vw/2, vr[1] - vh/2, vr[2] + vw, vr[3] + vh]
self.imgView->GetProperty, VIEWPLANE_RECT=vr
;PRINT, '                  new vr=', vr
;self.imgImage->SetProperty, DIMENSIONS=[ow+dw, oh+dh]
geo = WIDGET_INFO(self.guiPanel, /GEOMETRY)
nw = geo.scr_xsize
nh = geo.scr_ysize
self.scrSize = [nw, nh]
self->Redraw
;PRINT, 'ldrsIMAGE::Resize, old:', ow, ',', oh, ', new:', nw, ',', nh
RETURN, 1
END

PRO ldrsIMAGE__define
  struct = { ldrsIMAGE, $
             INHERITS ldrsVIEW, $
             imgWin:OBJ_NEW(), $
             imgView:OBJ_NEW(), $
             imgModel:OBJ_NEW(), $
             imgExt:OBJ_NEW(), $
             imgPalette:OBJ_NEW(), $
             imgImage:OBJ_NEW(), $
             nTools:0, $
             tools:OBJARR(10), $
             selTool:OBJ_NEW(), $
             guiFileName:0, $
             guiPrevBtn:0, $
             guiNextBtn:0, $
             guiNrTxt:0, $
             imgFile:OBJ_NEW(), $
             imgData:PTR_NEW(), $
             imgNImages:0, $
             imgImgNr:0, $
             drW:0, $
             drH:0, $
             viewOrgX:0, $
             viewOrgY:0, $
             scale:0, $
             scaleF:1.0 $
           }
END
