FUNCTION ldrsIMGAREA::Init, tool, nr, font
IF NOT self->ldrsIMGPOINT::Init(tool, nr, font) THEN RETURN, 0
;PRINT, 'ldrsIMGAREA::Init, col=', self.col
RETURN, 1
END

PRO ldrsIMGAREA::Update
self->ldrsIMGPOINT::Update
; update the box (only if requested)
IF self.boxFlag THEN BEGIN
    pos = [[-self.mLeft,  -self.mBottom], $
           [ self.mRight, -self.mBottom], $
           [ self.mRight,  self.mTop], $
           [-self.mLeft,   self.mTop]]
    pos[0, *] += self.pX
    pos[1, *] += self.pY
    IF NOT OBJ_VALID(self.boxObj) THEN BEGIN
        self.boxObj = OBJ_NEW('IDLgrPolygon', pos, STYLE=1, THICK=2, COLOR=self.col)
        self->ADD, self.boxObj
    ENDIF ELSE BEGIN
        self.boxObj->SetProperty, DATA=pos
    ENDELSE
ENDIF
END

PRO ldrsIMGAREA::GetCenter, cx, cy
IF self.mMode EQ 3 THEN BEGIN
    cx = self.pX + self.mRight/2
    cy = self.pY + self.mTop/2
ENDIF ELSE BEGIN
    cx = self.pX
    cy = self.pY
ENDELSE
END

PRO ldrsIMGAREA::SetCenter, cx, cy
IF self.mMode EQ 3 THEN BEGIN
    self.pX = cx - self.mRight/2
    self.pY = cy - self.mTop/2
ENDIF ELSE BEGIN
    self.pX = cx
    self.pY = cy
ENDELSE
END

PRO ldrsIMGAREA::GetSize, SIZE=s, WIDTH=w, HEIGHT=h, LEFT=l, RIGHT=r, TOP=t, BOTTOM=b
IF N_ELEMENTS(s) NE 0 THEN s = (self.mLeft + self.mRight + self.mLeft + self.mRight)/2
w = self.mLeft + self.mRight
h = self.mTop + self.mBottom
IF N_ELEMENTS(l) NE 0 THEN l = self.mLeft
IF N_ELEMENTS(r) NE 0 THEN r = self.mRight
IF N_ELEMENTS(t) NE 0 THEN t = self.mTop
IF N_ELEMENTS(b) NE 0 THEN b = self.mBottom
END

PRO ldrsIMGAREA::SetSize, SIZE=s, WIDTH=w, HEIGHT=h, LEFT=l, RIGHT=r, TOP=t, BOTTOM=b
CASE self.mMode OF
    0: BEGIN
        ; individual margins (maybe centered)
        IF N_ELEMENTS(s) NE 0 THEN BEGIN
            self.mLeft = s/2
            self.mRight = s/2
            self.mTop = s/2
            self.mBottom = s/2
        ENDIF
        IF N_ELEMENTS(w) NE 0 THEN BEGIN
            self.mLeft = w/2
            self.mRight = w/2
        ENDIF
        IF N_ELEMENTS(h) NE 0 THEN BEGIN
            self.mTop = h/2
            self.mBottom = h/2
        ENDIF
        IF N_ELEMENTS(l) NE 0 THEN self.mLeft = l
        IF N_ELEMENTS(r) NE 0 THEN self.mRight = r
        IF N_ELEMENTS(t) NE 0 THEN self.mTop = t
        IF N_ELEMENTS(b) NE 0 THEN self.mBottom = b
    END
    1: BEGIN
        ; left and right are equal, top and bottom are equal
        IF N_ELEMENTS(s) NE 0 THEN BEGIN
            self.mLeft = s/2
            self.mRight = s/2
            self.mTop = s/2
            self.mBottom = s/2
        ENDIF
        IF N_ELEMENTS(w) NE 0 THEN BEGIN
            self.mLeft = w/2
            self.mRight = w/2
        ENDIF
        IF N_ELEMENTS(h) NE 0 THEN BEGIN
            self.mTop = h/2
            self.mBottom = h/2
        ENDIF
        IF N_ELEMENTS(l) NE 0 THEN BEGIN
            self.mLeft = l
            self.mRight = l
        ENDIF
        IF N_ELEMENTS(r) NE 0 THEN BEGIN
            self.mLeft = r
            self.mRight = r
        ENDIF
        IF N_ELEMENTS(t) NE 0 THEN BEGIN
            self.mTop = t
            self.mBottom = t
        ENDIF
        IF N_ELEMENTS(b) NE 0 THEN BEGIN
            self.mTop = b
            self.mBottom = b
        ENDIF
    END
    2: BEGIN
        ; all margins are equal
        IF N_ELEMENTS(s) NE 0 THEN BEGIN
            self.mLeft = s/2
            self.mRight = s/2
            self.mTop = s/2
            self.mBottom = s/2
        ENDIF
        IF N_ELEMENTS(w) NE 0 THEN BEGIN
            self.mLeft = w/2
            self.mRight = w/2
            self.mTop = w/2
            self.mBottom = w/2
        ENDIF
        IF N_ELEMENTS(h) NE 0 THEN BEGIN
            self.mLeft = h/2
            self.mRight = h/2
            self.mTop = h/2
            self.mBottom = h/2
        ENDIF
        IF N_ELEMENTS(l) NE 0 THEN BEGIN
            self.mLeft = l
            self.mRight = l
            self.mTop = l
            self.mBottom = l
        ENDIF
        IF N_ELEMENTS(r) NE 0 THEN BEGIN
            self.mLeft = r
            self.mRight = r
            self.mTop = r
            self.mBottom = r
        ENDIF
        IF N_ELEMENTS(t) NE 0 THEN BEGIN
            self.mLeft = t
            self.mRight = t
            self.mTop = t
            self.mBottom = t
        ENDIF
        IF N_ELEMENTS(b) NE 0 THEN BEGIN
            self.mLeft = b
            self.mRight = b
            self.mTop = b
            self.mBottom = b
        ENDIF
    END
    3: BEGIN
        ; left and bottom are zero, right and top are different
        IF N_ELEMENTS(s) NE 0 THEN BEGIN
            self.mLeft = 0
            self.mRight = s
            self.mTop = s
            self.mBottom = 0
        ENDIF
        IF N_ELEMENTS(w) NE 0 THEN BEGIN
            self.mLeft = 0
            self.mRight = w
        ENDIF
        IF N_ELEMENTS(h) NE 0 THEN BEGIN
            self.mTop = h
            self.mBottom = 0
        ENDIF
        IF N_ELEMENTS(r) NE 0 THEN BEGIN
            self.mLeft = 0
            self.mRight = r
        ENDIF
        IF N_ELEMENTS(t) NE 0 THEN BEGIN
            self.mTop = t
            self.mBottom = 0
        ENDIF
    END
ELSE:
ENDCASE
self->Update
END

PRO ldrsIMGAREA::GetBoundingBox, x, y, w, h
x = self.pX - self.mLeft
y = self.pY - self.mBottom
w = self.mLeft + self.mRight
h = self.mBottom + self.mTop
END

FUNCTION ldrsIMGAREA::GetMarginMode
RETURN, mMode
END

PRO ldrsIMGAREA::GetMargins, left, right, top, bottom
left = self.mLeft
right = self.mRight
top = self.mTop
bottom = self.mBottom
END

PRO ldrsIMGAREA::SetMargins, left, right, top, bottom
self.mLeft = left
self.mRight = right
self.mTop = top
self.mBottom = bottom
self->Update
END

PRO ldrsIMGAREA::GetSky, skyAlgo, sky1, sky2, sky3, sky4
skyAlgo = self.skyAlgo
sky1 = self.sky1
sky2 = self.sky2
sky3 = self.sky3
sky4 = self.sky4
END

PRO ldrsIMGAREA::SetSky, skyAlgo, sky1, sky2, sky3, sky4
self.skyAlgo = skyAlgo
self.sky1 = sky1
self.sky2 = sky2
self.sky3 = sky3
self.sky4 = sky4
END

PRO ldrsIMGAREA::Enlarge
self.mLeft *= 2
self.mRight *= 2
self.mTop *= 2
self.mBottom *= 2
self->Update
END

PRO ldrsIMGAREA::Shrink
self.mLeft /= 2
self.mRight /= 2
self.mBottom /= 2
self.mTop /= 2
self->Update
END

PRO ldrsIMGAREA::ChangeColor, col
self->ldrsIMGPOINT::ChangeColor, col
IF self.boxFlag THEN self.boxObj->SetProperty, COLOR=col
END

PRO ldrsIMGAREA::Store, cfg
self->ldrsIMGPOINT::Store, cfg
cfg->SetFloat4D, 'BOX', self.mLeft, self.mRight, self.mTop, self.mBottom
cfg->SetInt, 'SKYALGO', self.skyAlgo
cfg->SetFloat, 'SKY1', self.sky1
cfg->SetFloat, 'SKY2', self.sky2
cfg->SetFloat, 'SKY3', self.sky3
cfg->SetFloat, 'SKY4', self.sky4
END

PRO ldrsIMGAREA::Load, cfg
self->ldrsIMGPOINT::Load, cfg
cfg->GetFloat4D, 'BOX', l, r, t, b
self.mLeft = l
self.mRight = r
self.mTop = t
self.mBottom = b
self.skyAlgo = cfg->GetInt('SKYALGO')
self.sky1 = cfg->GetFloat('SKY1')
self.sky2 = cfg->GetFloat('SKY2')
self.sky3 = cfg->GetFloat('SKY3')
self.sky4 = cfg->GetFloat('SKY4')
self->Update
END

PRO ldrsIMGAREA__define
  struct = { ldrsIMGAREA, $
             INHERITS ldrsIMGPOINT, $
             mMode:0, mLeft:64.0, mRight:64.0, mTop:64.0, mBottom:64.0, $
             skyAlgo:0, sky1:0.0, sky2:0.0, sky3:0.0, sky4:0.0, $
             boxFlag:0, boxObj:OBJ_NEW() $
           }
END
