FUNCTION ldrsPROBE::Init, tool, nr, font
IF NOT self->ldrsIMGAREA::Init(tool, nr, font) THEN RETURN, 0
self.crossFlag = 0
self.labelFlag = 1
self.boxFlag = 1
self.mMode = 3
self.uptodate = 0
RETURN, 1
END

PRO ldrsPROBE::Update
self->ldrsIMGAREA::Update
self.uptodate = 0
END

PRO ldrsPROBE::Move, dx, dy
self->ldrsIMGAREA::Move, dx, dy
self.uptodate = 0
END

PRO ldrsPROBE::RecalcValues
IF self.uptodate THEN RETURN
view = self.otool->GetView()
view->GetImage, img, nr
s = SIZE(*img)
left = self.pX
right = self.pX+self.mRight-1
bottom = self.pY
top = self.pY+self.mTop-1
IF left LT 0 THEN left = 0
IF right GE s[1] THEN right = s[1]-1
IF bottom LT 0 THEN bottom = 0
IF top GE s[2] THEN top = s[2]-1
w=right-left+1
h=top-bottom+1
n = w*h
self.size = n
ipart = (*img)[left:right,bottom:top,nr]
self.tot = TOTAL(ipart)
self.size = w*h
self.med = MEDIAN(ipart)
self.imax = MAX(ipart, imaxIdx, MIN=minval, SUBSCRIPT_MIN=iminIdx)
self.imin = minval
self.imaxX = left + imaxIdx MOD w
self.imaxY = bottom + imaxIdx/w
self.iminX = left + iminIdx MOD w
self.iminY = bottom + iminIdx/w
self.mean = self.tot/n
resid = ipart - self.mean
sumx=0.0
sumy=0.0
sum = 0.0
limit = self.mean + 0.1*(self.imax - self.mean)
FOR i=0,w-1 DO BEGIN
    FOR j=0,h-1 DO BEGIN
        IF ipart[i,j] GT limit THEN BEGIN
            sum += ipart[i,j]
            sumx += i*ipart[i,j]
            sumy += j*ipart[i,j]
        ENDIF
    ENDFOR
ENDFOR
self.centerX = left + sumx/sum
self.centerY = bottom + sumy/sum
self.var = (TOTAL(resid^2) - (TOTAL(resid)^2)/n)/(n - 1.0)
IF self.var NE 0 THEN BEGIN
    sdev = SQRT(self.var)
    self.skew = TOTAL(resid^3)/(n*sdev^3)
    self.kurt = TOTAL(resid^4)/(n*sdev^4) - 3.0
ENDIF ELSE BEGIN
    self.skew = 0.0
    self.kurt = 0.0
ENDELSE
self.uptodate = 1
END

PRO ldrsPROBE::GetTotal, value, npix
self->RecalcValues
value = self.tot
npix = self.size
END

PRO ldrsPROBE::GetPeak, cx, cy
cx = self.centerX
cy = self.centerY
END

FUNCTION ldrsPROBE::GetMedian
RETURN, self.med
END

PRO ldrsPROBE::GetMin, value, x, y
value = self.imin
x = self.iminX
y = self.iminY
END

PRO ldrsPROBE::GetMax, value, x, y
value = self.imax
x = self.imaxX
y = self.imaxY
END

FUNCTION ldrsPROBE::GetMean
self->RecalcValues
RETURN, self.mean
END

FUNCTION ldrsPROBE::GetVariance
self->RecalcValues
RETURN, self.var
END

FUNCTION ldrsPROBE::GetSkew
self->RecalcValues
RETURN, self.skew
END

FUNCTION ldrsPROBE::GetKurtosis
self->RecalcValues
RETURN, self.kurt
END

PRO ldrsPROBE__define
  struct = { ldrsPROBE, $
             INHERITS ldrsIMGAREA, $
             uptodate:0, $
             tot:0.0, size:0L, med:0.0, $
             centerX:0.0, centerY:0.0, $
             imin:0.0, iminX:0L, iminY:0L, $
             imax:0.0, imaxX:0L, imaxY:0L, $
             mean:0.0, var:0.0, skew:0.0, kurt:0.0 $
           }
END
